;
;  Special keyboard driver for Function Keys 11 and 12
;
KEYF11	equ		057h
KEYF12	equ		058h
F11		equ		085h
F12		equ		086h
ALT		equ		008h
CTL		equ		004h
SHFT	equ		003h
;
;-- Bios fixed memory layout
;
bios	segment	at 040h
		org	017h
bstate	db	?
		org	01Ah
bhead	dw	?
btail	dw	?
		org	080h
btop	dw	?
bend	dw	?
bios	ends
;
;--  driver code 
;
code	segment
		org		0100h
		assume	cs:code
start	label	far
		jmp		install

		even
old9vec	dw		2 dup (?)
;
;-- Keyboard interrupt handler
;
kbint	proc	far
		push	ax
		in		al,60h			; get keyboard character
		cmp		al,KEYF11
		  je	kbf11
		cmp		al,KEYF12
		  je	kbf12
		pop		ax
		jmp		dword ptr old9vec	; Not special -- handle with BIOS
;
;-- map to correct character
;
;		F11 -> 85h			F12 -> 86h
;	Shf F11 -> 87h		Shf F12 -> 88h
;	Ctl F11 -> 89h		Ctl F12 -> 8Ah
;	Alt F11 -> 8Bh		Alt F12 -> 8Ch
;
kbf11:	mov		ah,F11
		jmp		short kbclr

kbf12:	mov		ah,F12
		jmp		short kbclr
;
;-- clear keyboard int
;
kbclr:	in		al,61h
		or		al,80h
		out		61h,al
		and		al,7Fh
		out		61h,al
		mov		al,20h
		out		20h,al		; eoi
;
;-- Adjust for keyboard state
;
		push	bx
		push	ds
		mov		bx,bios
		mov		ds,bx
		assume	ds:bios
		mov		al,bstate
		test	al,ALT
		  jne	kbalt
		test	al,CTL
		  jne	kbctl
		test	al,SHFT
		  jne	kbshft
		jmp		short kbput

kbalt:	add		ah,2
kbctl:	add		ah,2
kbshft:	add		ah,2
;
;-- stuff char into buffer
;
kbput:	mov		bx,btail
		add		bx,2
		cmp		bx,bend			; wrap around ?
		  jne	kb20
		mov		bx,btop
kb20:	cmp		bx,bhead		; tail == end ?
		  je	kb30			; no room
		xchg	btail,bx
		xor		al,al
		mov		[bx],ax
kb30:	pop		ds
		pop		bx
		pop		ax
		iret
kbint	endp

hello	db 13,10,'Keyboard Interrupt Driver Rev 1.0',13,10,'$'

		assume ds:code

install	proc near
		mov		dx,offset hello
    	mov		ah,9
	    int		21h
		mov		ax,3509h			; get current interrupt vector
		int		21h
		mov		old9vec,bx
		mov		old9vec[2],es
		mov		ax,2509h			; set new interrupt vector
		mov		dx,offset kbint
		int		21h
		mov		dx,offset hello
		int		27h
install	endp

code	ends
		end  start
